function P = LEX_TO_RB_PERM_Rect(N,M,direction)

    O_rb = getRedBlackOrderingRect(N,M);
    O_lex = getLEXOrderingRect(N,M);
    
    P = zeros(N*M,1);
    
    if strcmp(direction,'forward')
    
        O1=O_lex;
        O2=O_rb;
        
    elseif strcmp(direction,'backward')
        
        O1=O_rb;
        O2=O_lex;
    
    else
        
        error('invalid direction.  Please enter one of "forward", "backward"');
        
    end
    
    for j=1:N
        for k=1:M
            P(O1(j,k))=O2(j,k);
        end
    end
    
    