function L = getL_3D(a,c1m,c1p,c2m,c2p,c3m,c3p,N)

    S1 = sparse(c1p*diag(ones(N-1,1),1)+c1m*diag(ones(N-1,1),-1));
    S2 = sparse(c2p*diag(ones(N-1,1),1)+c2m*diag(ones(N-1,1),-1));
    S3 = sparse(c3p*diag(ones(N-1,1),1)+c3m*diag(ones(N-1,1),-1));
    
    L = a*speye(N^3)+kron(S1,kron(speye(N),speye(N)))+kron(speye(N),kron(S2,speye(N)))+kron(speye(N),kron(speye(N),S3));