function setup = getRBStuff(Ls,setup)


    RB_stuff={};
    
    for l = setup.minLevel+1:setup.level
        
        N = 2^l-setup.delta;
        
        if ~strcmp(setup.coefficients,'Marmousi')
            Perm = LEX_TO_RB_PERM(N,setup.dimension,"backward");
            invPerm = LEX_TO_RB_PERM(N,setup.dimension,"forward");
        else        
            Perm = LEX_TO_RB_PERM_Rect(3*N+2*setup.delta,N,"backward");
            invPerm = LEX_TO_RB_PERM_Rect(3*N+2*setup.delta,N,"forward");
        end
        
        L_h = Ls{l};
        
        L_h = L_h(Perm,Perm);

        [N_to_the_d,~]=size(L_h);

        N_r = ceil(N_to_the_d/2);

        L_rb=L_h(1:N_r,N_r+1:end);
        L_br=L_h(N_r+1:end,1:N_r);
        D_r=L_h(1:N_r,1:N_r);
        D_b=L_h(N_r+1:end,N_r+1:end);
        
        
        RB_stuff{l}={N_r,D_r,D_b,L_rb,L_br,Perm,invPerm};
            

        
    end
    
    setup.RB_stuff=RB_stuff;