function O = getRedBlackOrdering(N,d)

    if d==2

        O = zeros(N,N);
        
    elseif d==3
        
        O = zeros(N,N,N);
        
    else
        error('invalid dimension')
    end
    
    count = 1;
    
    if d==2
    
        for pass = 1:2

            for j=1:N
                for k=1:N

                    if pass == 1 && mod(j+k,2)==0
                        O(j,k)=count;
                        count = count+1;
                    elseif pass == 2 && mod(j+k,2)==1
                        O(j,k)=count;
                        count = count+1;
                    end

                end
            end

        end
    elseif d==3
        
        for pass = 1:2

            for j=1:N
                for k=1:N
                    for l=1:N

                        if pass == 1 && mod(j+k+l,2)==0
                            O(j,k,l)=count;
                            count = count+1;
                        elseif pass == 2 && mod(j+k+l,2)==1
                            O(j,k,l)=count;
                            count = count+1;
                        end
                    
                    end
                end
            end

        end
    end