function L = getL_2g(setup,theta1,theta2,level)

    % somewhat counterintuitively, L_2g is not necessarily the operator on
    % level two.  Hence level is an explicit parameter

    L = zeros(4,4);
    
    
    alpha = [0 1 1 0;
             0 1 0 1];
    

         
    for l=1:4
        
        alphaX = alpha(1,l);
        alphaY = alpha(2,l);
        
        theta1p = theta1-(alphaX*mod_sign(theta1))*pi;
        theta2p = theta2-(alphaY*mod_sign(theta2))*pi;
        
        L(l,l)=getL(setup,theta1p,theta2p,level);
        
    end
        
    