function P = LEX_TO_RB_PERM(N,d,direction)


    O_rb = getRedBlackOrdering(N,d);
    O_lex = getLEXOrdering(N,d);
    
    P = zeros(N^d,1);
    
    if strcmp(direction,'forward')
    
        O1=O_lex;
        O2=O_rb;
        
    elseif strcmp(direction,'backward')
        
        O1=O_rb;
        O2=O_lex;
    
    else
        
        error('invalid direction.  Please enter one of "forward", "backward"');
        
    end
    
    if d==2
    
    for j=1:N
        for k=1:N
            P(O1(j,k))=O2(j,k);
        end
    end
    
    elseif d==3
    for j=1:N
        for k=1:N
            for l=1:N
                P(O1(j,k,l))=O2(j,k,l);
            end
        end
    end    
        
    else
        error('invalid dimension')
    end
    
    