function [A,c,c_m]=extract_matrix_entrees_rect(L_h,N,M)

    A=full(diag(L_h));
    c1p = full(diag(L_h,1));
    c1m = full(diag(L_h,-1));
    c1p = [c1p;0];
    c1m = [0;c1m];
    
    Ip = speye(M);
    Ip(M,M)=0;
    Im = sparse(M,M);
    Im(M,M)=1;
    I = speye(N);
    
    Ipp = kron(I,Ip);
    Imm = kron(I,Im);
    
    
    c1 = Ipp*c1p+Imm*c1m;
    
    
    
    c2p = [full(diag(L_h,M));zeros(M,1)];
    c2m = [zeros(M,1);full(diag(L_h,-M))];
    
    Ip = speye(N);
    Ip(N,N)=0;
    Im = sparse(N,N);
    Im(N,N)=1;
    I = speye(M);
    
    Ipp = kron(Ip,I);
    Imm = kron(Im,I);
    
    c2 = Ipp*c2p+Imm*c2m;
    
    c1 = -c1;
    c2 = -c2;
    
    c = c1+c2;
    c_m = min([c1,c2],[],2); % elementwise min of c1,c2
    