function [nu1,nu2]=getNu1Nu2(setup)

    if strcmp(setup.smoother,'RB-SOR')
        if setup.nu ==1
            nu1=1;
            nu2=0;
        elseif setup.nu ==2
            nu1=1;
            nu2=1;
        else
            error('for RB-SOR, we should have nu=1 or nu=2')
        end
            
    elseif strcmp(setup.smoother,'DAMPED-JACOBI')
        % split as evenly as possible between pre- and post-smoothing.
        nu1 = floor(setup.nu/2);
        nu2 = ceil(setup.nu/2);
    end