% gets a 2D slice along the midpoint of a 3D function.  F should be 3D.

function [X,Y,F_2D]=get_F_mid(X,Y,F)

    [N,~,~]=size(F);

    % plot the middle (using interpolation if necessary)
    N_mid_floor = floor(N/2);
    N_mid_ceil = ceil(N/2);
    F_2D = (F(:,:,N_mid_floor)+F(:,:,N_mid_ceil))/2;
    X = X(:,:,1);
    Y = Y(:,:,1);