function setup = buildDirectShiftedLaplacianSetup(alpha,epsilon,kh,nu1,nu2,w,smoother)

     L1 = [4-kh^2*(1-1i*alpha),-epsilon,-(2-epsilon),0];
     L2 = [4-4*kh^2*(1-1i*alpha),-epsilon,-(2-epsilon),0];
    
    L{1}=L1;
    L{2}=L2;
    
    P1 = (1/4)*[4,2,2,1];
    P2 = (1/4)*[4,2,2,1];
    
    P{1}=P1;
    P{2}=P2;
    
    R1 = (1/16)*[4,2,2,1];
    R2 = (1/16)*[4,2,2,1];
    
    R{1}=R1;
    R{2}=R2;
    
    setup.L = L;
    setup.R = R;
    setup.P = P;
    
   
   setup.nu1 = nu1;
   setup.nu2 = nu2;
   
    
    
    setup.w=w;
    
    setup.smoother=smoother;
    
    
    