function Z=get2LevelSpectrum(setup)

    % setup is the setup of the matrix we're applying multigrid to

    N = 301;
    
    Z=zeros(4*N^2,1);
    
    count = 1;
    
    level = 1;
    
    for ii=1:N
        
        
        for jj=1:N
            
            theta1 = -(pi/2)+ii*(pi)/N;
            theta2 = -(pi/2)+jj*(pi)/N;
            
            M_2g = getM2g(setup,theta1,theta2,level);
            
            
            if abs(det(M_2g))>0
            
                [~,D] = eig(M_2g);
                
                
                for k=1:length(D)
                    Z(count)=D(k,k);
                    count = count+1;
                end

            end
            
        end
    end