function M=getM2g(setup,theta1,theta2,level)

    % level could be 1 or 2, because we might be talking about the two grid
    % operator directly, or we might already be one level down.

    nu1 = setup.nu1;
    nu2 = setup.nu2;
    
    S_2g = getS_2g(setup,theta1,theta2,level);
    P_2g = getP_2g(setup,theta1,theta2,level);
    R_2g = getR_2g(setup,theta1,theta2,level);
    
    L_2g = getL_2g(setup,theta1,theta2,level);
    Lscript_2g = getScriptL_2g(setup,theta1,theta2,level+1); % level+1 because down a level.
    
    M = (S_2g^nu2)*(eye(4)-P_2g*inv(Lscript_2g)*R_2g*L_2g)*(S_2g^nu1);
    
  