function [wC,rho2G]=optimal2G(setup,w0)

    f = @(w)twoLevelWrapperFunction(w,setup);
    w0 = [real(w0);imag(w0)];
    %options = optimset('PlotFcns',@optimplotfval);
    %options = optimset;
    options = optimset('TolX',1e-8,'MaxFunEvals',40);
    [w,fval] = fminsearch(f,w0,options);
    wC = w(1)+1i*w(2);
    rho2G = fval;